<?php

namespace Drupal\taxonomy_search_admin_form\tests\src\Unit;

use Drupal\Tests\UnitTestCase;
use Drupal\taxonomy\Entity\Term;
use Drupal\Core\Entity\EntityStorageInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;

/**
 * Unit test for taxonomy search.
 *
 * @group taxonomy_search
 */
class TaxonomyTermExistsTest extends UnitTestCase {

  /**
   * Test for taxonomy search by term id.
   */
  public function testTermExists() {

    $term_id = 123;
    $term = $this->createMock(Term::class);
    $term->expects($this->once())
      ->method('id')
      ->willReturn($term_id);

    $term_storage = $this->createMock(EntityStorageInterface::class);
    $term_storage->expects($this->once())
      ->method('load')
      ->with($term_id)
      ->willReturn($term);

    $entity_type_manager = $this->createMock(EntityTypeManagerInterface::class);
    $entity_type_manager->expects($this->once())
      ->method('getStorage')
      ->with('taxonomy_term')
      ->willReturn($term_storage);

    $loaded_term = $entity_type_manager->getStorage('taxonomy_term')->load($term_id);
    $this->assertInstanceOf(Term::class, $loaded_term);
    $this->assertEquals($term_id, $loaded_term->id());
  }

}
